> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/containers/managed-kubernetes/maintenance.md).

# Maintenance Window

Managed Kubernetes maintenance window: automated weekly maintenance for clusters and node pools, including upgrade behaviour and scheduling on IONOS CLOUD.

All Managed Kubernetes resources, such as clusters and node pools, are subject to an **automated weekly maintenance** process. All changes to a cluster or node pools that may cause service interruption, such as upgrades, are executed during maintenance. During the maintenance window, you may encounter uncontrolled disconnections and an inability to connect to the cluster.

The upgrade process during maintenance respects the selected Kubernetes version of the cluster. The upgrade process does not upgrade to another Kubernetes major, minor, or patch version unless the current cluster or node pool version reaches its end of life. In such instances, the cluster or node pool will be updated to the **next minor version** that is **active**.

## Maintenance window configuration

The maintenance window consists of two parts. The first part specifies the **day of the week**, while the second part specifies the **expected time**. The following example shows a maintenance window configuration:

```
"maintenanceWindow": {
      "time": "15:39:01",
      "dayOfTheWeek": "Friday"
    },

```

For more information, see [<mark style="color:blue;">Create a Cluster</mark>](/cloud/containers/managed-kubernetes/how-tos/cluster_management.md).

## Cluster maintenance

During cluster maintenance, control plane components are upgraded to the **newest version** available.

### Node pool maintenance

During the maintenance of a particular node pool, all nodes of this pool will be replaced by new nodes. Nodes are replaced one after the other, starting with the oldest node. During the node replacement, first, a new node is created and added to the cluster. Then, the old node is drained and removed from the cluster. Node pool upgrade considers the **four-hour maintenance window**. The upgrade process will be continued in the **next node pool maintenance** if it fails to upgrade all nodes of the node pool within the **four-hour maintenance window**.

### Node drain and PodDisruptionBudgets (PDBs)

The maintenance process first attempts to drain a node gracefully, respecting the given PDBs across multiple retries. If this fails, the node is drained, ignoring pod disruption budgets.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/containers/managed-kubernetes/maintenance.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
